<?php
/*
 * 分页显示类
 * PageNav.class.php　v 1.0.0
 * 编程：大白菜芯<php_netproject@yahoo.com.cn>
 * 更新：2004-02-02
 * 说明：
 * 1. 配合MYSQL数据库使用
 * 2. 类没有提供连接数据库的功能，需在外部建立数据库连接。
 * */
/*
 * 使用方法：
 * $sql = "select * from news limit 0,10";
 * $Pagenav = new PageItem($sql);
 * echo $Pagenav->myPageItem();
 * $arrRecords = $Pagenav->ReadList();
 * */
if (!defined("__PAGEITEM__")) {
    define("__PAGEITEM__", 1);
} else {
    exit(3);
} 

class PageItem {
    //var $iDefaultRecords = 10; // 默认每页显示记录数，如果没有设置，就使用默认值
    var $iMaxRecord; //每页记录数
    var $iTotal; //记录总数
    var $sqlRecord; // 获取记录的SQL查询
    var $iPages; //总页数
    var $CPages; //当前页数

    /*  * 构造函数 －－ 初始化变量  * 参数：SQL查询语句，将忽略LIMIT语句  * */

    function PageItem($sql,$num)
    { 
        global $DB;
        $this->iDefaultRecords = $num;
		    $this->SetMaxRecord($this->iDefaultRecords);
        /*  *  解析SQL语句       * */
        if ($sql != "") {
            list($sql) = spliti("LIMIT", $sql); // 去除LIMIT语句
            $this->sqlRecord = trim($sql);
            list(, $sql) = spliti("FROM", $sql);
            $sql = trim($sql);

           if(preg_match ("/\bGROUP\b \bBY\b/i", $sql))
           {
              if(preg_match ("/\bHAVING\b/i", $sql)) list(,$field) = spliti("HAVING",$sql);
            
               list($field) = spliti(' ',trim($field));
               $this->iTotal = $this->CountRecord("SELECT $field,COUNT(DISTINCT $field) AS cnt FROM " . $sql,2);
               
           }else  {
           $this->iTotal = $this->CountRecord("SELECT COUNT(*) AS cnt FROM " . $sql,1);
           }
        } 
        
        $this->iPages = ceil($this->iTotal / $this->iMaxRecord);
        $this->CPages = $_REQUEST['page'];
        if ($this->CPages <= 0) $this->CPages = 1;
        if ($this->CPages > $this->iPages) $this->CPages = $this->iPages;
     } 

    function SetMaxRecord($cnt)
    {
        $this->iMaxRecord = $cnt;
    } 

    /* * 统计匹配的记录总数  * */
    function CountRecord($sql,$type)
    {
    global $DB;
  if($type == 1)
  {
   if (($records = $DB->query($sql)) && ($record =  $DB->fetch_assoc($records))) {
    return $record['cnt'];
   } else return 0;
  }
  elseif($type == 2)
  {
   if($records =  $DB->query($sql))
    return $DB->affected_rows();
  }
    }
 /*  * 读取记录 * */
 function ReadList()
 {
  global $DB;
  $StartPage = intval($this->CPages-1)<=0 ? 0 : $this->CPages-1 ;
  $this->sqlRecord.=" LIMIT ".$StartPage*$this->iMaxRecord.",".$this->iMaxRecord;
  //$this->sqlRecord.=" LIMIT ".($this->CPages-1)*$this->iMaxRecord.",".$this->iMaxRecord;
  
  $records = $DB->query($this->sqlRecord);
  $num     = $DB->num_rows($records);
  
  if($num>0){
    return $records;
  }else{
    return 0;	
  }
 }
 
    function LinktoPage($page, $msg)
    {
        $link = $this->PageUrl($page);
        return "<A href=\"$link\">$msg</A>\n";
    } 
    function PageUrl($page)
    {   
		global $INFO;
        //$phpself = "http://" . $_SERVER['SERVER_NAME'] . $_SERVER['PHP_SELF'];
        //$phpself = "http://127.0.0.1" . $_SERVER['PHP_SELF'];
		$phpself = $INFO['site_url'] . $_SERVER['PHP_SELF'];
        $querystring = $_SERVER['QUERY_STRING'];
        $querystring = preg_replace("/page=[0-9]*&?/i", "", $querystring);
        $link = $phpself . "?page=$page&" . $querystring;
        return $link;
    } 

    /*  * 显示当前页及总页数     * */
    function PageNav()    
    {
    	global $PROG_TAGS,$INFO;  
		//$PROG_TAGS["ptag_792"]  第
		//$PROG_TAGS["ptag_1878"] 页/共
		//$PROG_TAGS["ptag_790"]  页
		
        return  $PROG_TAGS["ptag_792"]." ".$this->CPages.$PROG_TAGS["ptag_1878"].$this->iPages." ".$PROG_TAGS["ptag_790"];
    } 

    /* * 显示翻页按钮，包括首页、下页、上页、未页   * */

    function PageButton()
    {
		global $PROG_TAGS;  
        // $PROG_TAGS["ptag_1618"] = "首页";
		// $PROG_TAGS["ptag_1615"] = "最后页"; 
        // $PROG_TAGS["ptag_1616"] = "下一页"; 
        // $PROG_TAGS["ptag_1617"] = "前一页"; 

    	  $Pagebutton="";
        if ($this->CPages > 1) {
            $Pagebutton .= $this->LinktoPage(1, $PROG_TAGS["ptag_1618"]);
            $Pagebutton .= " | ";
            $Pagebutton .= $this->LinktoPage($this->CPages-1, $PROG_TAGS["ptag_1617"]);
        } else {
            $Pagebutton .= $PROG_TAGS["ptag_1618"]." | ". $PROG_TAGS["ptag_1617"];
        } 

        if ($this->CPages < $this->iPages) {
            $Pagebutton .= " | ";
            $Pagebutton .= $this->LinktoPage($this->CPages + 1, $PROG_TAGS["ptag_1616"]);
            $Pagebutton .= " | ";
            $Pagebutton .= $this->LinktoPage($this->iPages, $PROG_TAGS["ptag_1615"]);
        } else {
            $Pagebutton .= " | ".$PROG_TAGS["ptag_1616"]." | ".$PROG_TAGS["ptag_1615"];
        } 
        return $Pagebutton;
    }
    /* 
   * 显示跳转页选择框
   * */

    function SelectItem()
    {

		global $PROG_TAGS; 
    	//$PROG_TAGS["ptag_792"] = "第";
        //$PROG_TAGS["ptag_793"] = "跳转到";

    	$SelectItem = " ";
        $SelectItem .= $PROG_TAGS["ptag_793"].$PROG_TAGS["ptag_792"]."<SELECT name='topage' size='1' onchange='window.location=this.value'>\n";
        for($i = 1;$i <= $this->iPages;$i++) {
            if ($this->CPages == $i)
                $extra = "selected";
            else
                $extra = "";
            $SelectItem .= "<OPTION VALUE='" . $this->PageUrl($i) . "' $extra>$i</OPTION>";
        } 
        $SelectItem .= "</SELECT>\n";
        return $SelectItem;
    }

    /*
     * 一次性显示所有按钮组件
     * */
    function myPageItem()
    {
    	  $myPageItem = "";
        $myPageItem .= $this->PageButton().$this->SelectItem(). $this->PageNav();
        return $myPageItem;
    } 
} // 类结束

?>   
 
