<?php

//==========================================
// 函数: smtp($smtpserver,$smtpserverport,true,$smtpuser,$smtppass)
// 功能: 邮件发送

// 参数: $smtpserver      = "smtp.tom.com";//SMTP服务器
// 参数: $smtpserverport  = 25;//SMTP服务器端口
// 参数: $smtpusermail    = "phpcoder@tom.com";//SMTP服务器的用户邮箱
// 参数: $smtpemailto     = "phpcoder@tom.com,phpcoder@tom.com,phpcoder@sohu.com";//发送给谁
// 参数: $smtpuser        = "phpcoder";//SMTP服务器的用户帐号
// 参数: $smtppass        = "XXXXXX";//SMTP服务器的用户密码
// 参数: $mailsubject     = "Test Subject";//邮件主题
// 参数: $mailbody        = "<h1>This is a test mail</h1>";//邮件内容
// 参数: $mailtype        = "HTML";//邮件格式（HTML/TXT）,TXT为文本邮件

// 调用：
// $smtp = new smtp($smtpserver,$smtpserverport,true,$smtpuser,$smtppass);//这里面的一个true是表示使用身份验证,否则不使用身份验证.
// $smtp->debug = TRUE;//是否显示发送的调试信息
// $smtp->sendmail($smtpemailto, $smtpusermail, $mailsubject, $mailbody, $mailtype);

// FileName:SMTP.Class.inc.php
// Summary: STMP MAIL
// Author: tyler.wu(大白菜芯)
// CreateTime: 2005-7-2
// LastModifed:2005-7-2
// copyright (c)2005 php_netproject@yahoo.com.cn
// MSN ： java@cu165.com
//==========================================

class smtp

{

	/* Public Variables */

	var $smtp_port;

	var $time_out;

	var $host_name;

	var $log_file;

	var $relay_host;

	var $debug;

	var $auth;

	var $user;

	var $pass;

	/* Private Variables */
	var $sock;

	/* Constractor */

	function smtp($relay_host = "", $smtp_port = 25,$auth = false,$user,$pass)

	{

		$this->debug = FALSE;

		$this->smtp_port = $smtp_port;

		$this->relay_host = $relay_host;

		$this->time_out = 30; //is used in fsockopen()
		#

		$this->auth = $auth;//auth

		$this->user = $user;

		$this->pass = $pass;

		#

		$this->host_name = "localhost"; //is used in HELO command
		$this->log_file = "";



		$this->sock = FALSE;

	}

	/* Main Function */

	function sendmail($to, $from, $subject , $body, $mailtype, $cc = "", $bcc = "", $additional_headers = "")

	{

		$mail_from = $this->get_address($this->strip_comment($from));

		$body = ereg_replace("(^|(\r\n))(\.)", "\1.\3", $body);

		$header .= "MIME-Version:1.0\r\n";

		if($mailtype=="HTML"){

			$header .= "Content-Type:text/html;charset=utf-8\r\n";

			$header .= "Content-Transfer-Encoding: base64\n\n";


		}

		$header .= "To: ".$to."\r\n";

		if ($cc != "") {

			$header .= "Cc: ".$cc."\r\n";

		}

		$header .= "From: $from<".$from.">\r\n";

		$header .= "Subject: ".$subject."\r\n";

		$header .= $additional_headers;

		$header .= "Date: ".date("r")."\r\n";

		$header .= "X-Mailer:By Redhat (PHP/".phpversion().")\r\n";

		list($msec, $sec) = explode(" ", microtime());
		$TO = explode(",", $this->strip_comment($to));

		if ($cc != "") {

			$TO = array_merge($TO, explode(",", $this->strip_comment($cc)));

		}

		if ($bcc != "") {

			$TO = array_merge($TO, explode(",", $this->strip_comment($bcc)));

		}

		$this->Headers  = $header;
		$sent = TRUE;

		foreach ($TO as $rcpt_to) {

			$rcpt_to = $this->get_address($rcpt_to);

			if (!$this->smtp_sockopen($rcpt_to)) {

				$this->log_write("Error: Cannot send email to ".$rcpt_to."\n");

				$sent = FALSE;

				continue;

			}
			if ($this->smtp_send($this->host_name, $mail_from, $rcpt_to, $header, $body)) {

				$this->log_write("E-mail has been sent to <".$rcpt_to.">\n");

			} else {

				$this->log_write("Error: Cannot send email to <".$rcpt_to.">\n");

				$sent = FALSE;

			}

			fclose($this->sock);

			$this->log_write("Disconnected from remote host\n");

		}

		return $sent;

	}



	/* Private Functions */



	function smtp_send($helo, $from, $to, $header, $body = "")

	{
		if (!$this->smtp_putcmd("HELO", $helo)) {

			return $this->smtp_error("sending HELO command");

		}

		#auth

		if($this->auth){

			if (!$this->smtp_putcmd("AUTH LOGIN", base64_encode($this->user))) {

				return $this->smtp_error("sending HELO command");

			}

			if (!$this->smtp_putcmd("", base64_encode($this->pass))) {

				return $this->smtp_error("sending HELO command");

			}

		}

		#

		if (!$this->smtp_putcmd("MAIL", "FROM:<".$from.">")) {

			return $this->smtp_error("sending MAIL FROM command");

		}

		if (!$this->smtp_putcmd("RCPT", "TO:<".$to.">")) {

			return $this->smtp_error("sending RCPT TO command");

		}

		if (!$this->smtp_putcmd("DATA")) {

			return $this->smtp_error("sending DATA command");

		}


		if (!$this->smtp_message($header, $body)) {

			return $this->smtp_error("sending message");

		}

		if (!$this->smtp_eom()) {

			return $this->smtp_error("sending <CR><LF>.<CR><LF> [EOM]");

		}

		if (!$this->smtp_putcmd("QUIT")) {

			return $this->smtp_error("sending QUIT command");

		}

		return TRUE;

	}

	function smtp_sockopen($address)

	{

		if ($this->relay_host == "") {

			return $this->smtp_sockopen_mx($address);

		} else {

			return $this->smtp_sockopen_relay();

		}

	}

	function smtp_sockopen_relay()

	{

		$this->log_write("Trying to ".$this->relay_host.":".$this->smtp_port."\n");

		$this->sock = @fsockopen($this->relay_host, $this->smtp_port, $errno, $errstr, $this->time_out);

		if (!($this->sock && $this->smtp_ok())) {

			$this->log_write("Error: Cannot connenct to relay host ".$this->relay_host."\n");

			$this->log_write("Error: ".$errstr." (".$errno.")\n");

			return FALSE;

		}

		$this->log_write("Connected to relay host ".$this->relay_host."\n");

		return TRUE;;

	}



	function smtp_sockopen_mx($address)

	{

		$domain = ereg_replace("^.+@([^@]+)$", "\1", $address);

		if (!@getmxrr($domain, $MXHOSTS)) {

			$this->log_write("Error: Cannot resolve MX \"".$domain."\"\n");

			return FALSE;

		}

		foreach ($MXHOSTS as $host) {

			$this->log_write("Trying to ".$host.":".$this->smtp_port."\n");

			$this->sock = @fsockopen($host, $this->smtp_port, $errno, $errstr, $this->time_out);

			if (!($this->sock && $this->smtp_ok())) {

				$this->log_write("Warning: Cannot connect to mx host ".$host."\n");

				$this->log_write("Error: ".$errstr." (".$errno.")\n");

				continue;

			}

			$this->log_write("Connected to mx host ".$host."\n");

			return TRUE;

		}

		$this->log_write("Error: Cannot connect to any mx hosts (".implode(", ", $MXHOSTS).")\n");

		return FALSE;

	}



	function smtp_message($header, $body)

	{

		fputs($this->sock, $header."\r\n".$body);

		$this->smtp_debug("> ".str_replace("\r\n", "\n"."> ", $header."\n> ".$body."\n> "));



		return TRUE;

	}



	function smtp_eom()

	{

		fputs($this->sock, "\r\n.\r\n");

		$this->smtp_debug(". [EOM]\n");



		return $this->smtp_ok();

	}



	function smtp_ok()

	{

		$response = str_replace("\r\n", "", fgets($this->sock, 512));

		$this->smtp_debug($response."\n");



		if (!ereg("^[23]", $response)) {

			fputs($this->sock, "QUIT\r\n");

			fgets($this->sock, 512);

			$this->log_write("Error: Remote host returned \"".$response."\"\n");

			return FALSE;

		}

		return TRUE;

	}

	function smtp_putcmd($cmd, $arg = "")

	{

		if ($arg != "") {

			if($cmd=="") $cmd = $arg;

			else $cmd = $cmd." ".$arg;

		}

		fputs($this->sock, $cmd."\r\n");

		$this->smtp_debug("> ".$cmd."\n");

		return $this->smtp_ok();

	}

	function smtp_error($string)

	{

		$this->log_write("Error: Error occurred while ".$string.".\n");

		return FALSE;

	}

	function log_write($message)

	{

		$this->smtp_debug($message);

		if ($this->log_file == "") {

			return TRUE;

		}

		$message = date("M d H:i:s ").get_current_user()."[".getmypid()."]: ".$message;

		if (!@file_exists($this->log_file) || !($fp = @fopen($this->log_file, "a"))) {

			$this->smtp_debug("Warning: Cannot open log file \"".$this->log_file."\"\n");

			return FALSE;;

		}

		flock($fp, LOCK_EX);

		fputs($fp, $message);

		fclose($fp);


		return TRUE;

	}


	function strip_comment($address)

	{

		$comment = "\([^()]*\)";

		while (ereg($comment, $address)) {

			$address = ereg_replace($comment, "", $address);

		}


		return $address;

	}


	function get_address($address)

	{

		$address = ereg_replace("([ \t\r\n])+", "", $address);

		$address = ereg_replace("^.*<(.+)>.*$", "\1", $address);

		return $address;

	}

	function smtp_debug($message)

	{

		if ($this->debug) {

			return $message;

		}

	}

	/**
    *初始化电子邮件类
    */
	function Mailto($to,$title,$mailtext){
		global $INFO;
		include "email.class.php";
		$mail = new Email();
		$mail->setTo($to);
		$mail->setFrom($INFO['email']);
		$mail->setSubject($title);
		$mail_content=stripslashes($mailtext);
		$mail->setHTML($mail_content);
		$mail->send();
	}

	function MailForSmartshop($to,$MailSendType,$Array){
		global $DB,$INFO;

		/**
		 * 这里是后台群发部分的代码
		 */
		if ($MailSendType=="GroupSend" && is_array($Array)){
			$title       = $Array[mailsubject];
			$mailtext    = $Array[mailbody];
		}


		/**
		 * 下边是后台设置的一些固定项目的发送
		 */
		if (is_integer($MailSendType)) {
			$Query  = $DB->query(" select * from `{$INFO[DBPrefix]}sendtype` where sendtype_id=".intval($MailSendType)." and sendstatus=1 limit 0,1");
			$Num    = $DB->num_rows($Query);

			if ( $Num>0 ) {
				$Rs= $DB->fetch_array($Query);
				$title = str_replace ("@shopname@",$INFO['site_name'],$Rs['sendtitle']);
				$mailBody = $Rs['sendcontent'];

				/**
 * 获得相关变量 ，这里初始化为空
 */
				$mailtext = " ";
				/**
 * 获得基本信息相关变量
 */
				$mailtext = str_replace ("@shopname@",$INFO['site_title'],$mailBody);
				$mailtext = str_replace ("@site_url@",$INFO['site_url'],&$mailtext);
				$mailtext = str_replace ("@truename@",trim($Array['truename']),&$mailtext);
				$mailtext = str_replace ("@username@",trim($Array['username']),&$mailtext);
				$mailtext = str_replace ("@passwd@",trim($Array['password']),&$mailtext);
				$mailtext = str_replace ("@newpass@",trim($Array['f_pwd']),&$mailtext);
				/**
 * 获得用户交互信息相关变量
 */								
				$mailtext = str_replace ("@question@",trim($Array['question']),&$mailtext);
				$mailtext = str_replace ("@reply@",trim($Array['reply']),&$mailtext);
				$mailtext = str_replace ("@reply_title@",trim($Array['reply_title']),&$mailtext);
				$mailtext = str_replace ("@reply_result@",trim($Array['reply_result']),&$mailtext);
				/**
 * 获得定单信息相关变量
 */						
 				$mailtext = str_replace ("@ATM@",trim($Array['ATM']),&$mailtext);
 				$mailtext = str_replace ("@pay_name@",trim($Array['pay_name']),&$mailtext);
				$mailtext = str_replace ("@pay_content@",trim($Array['pay_content']),&$mailtext);
			    $mailtext = str_replace ("@pay_deliver@",trim($Array['pay_deliver']),&$mailtext);
				$mailtext = str_replace ("@orderid@",trim($Array['orderid']),&$mailtext);
				$mailtext = str_replace ("@orderinfo@",trim($Array['orderinfo']),&$mailtext);
				$mailtext = str_replace ("@orderamount@",trim($Array['orderamount']),&$mailtext);
				$mailtext = str_replace ("@receiver_address@",trim($Array['receiver_address']),&$mailtext);

				/**
 * 获得产品信息相关变量
 */					
				$mailtext = str_replace ("@goodsname@",trim($Array['goodsname']),&$mailtext);
				$mailtext = str_replace ("@goodslink@",trim($Array['goodslink']),&$mailtext);
			}
		}

		/**
  装入Smtp基本配置内容
 */

		include  "Smtp.config.php";
		include  "CharsetTool/CharsetTool.php";
		include  "CharsetTool/Util/String.php";

		$String  =new String();
		$charset =new CharsetTool();

		/**
  检测是否使用本地编码
*/

		if ($sel_mail_enc=='local'){

			switch ($sel_mail_lang){

				case "zh":
					$mailsubject =  $charset->conv($title, "utf8", "gb");
					$mailbody    =  $charset->conv($mailtext, "utf8", "gb");
					/**
   将数据判断是否目标是BIG，如果是，那么就将简体转换成BIG5
*/
					if ($sel_mail_tar_lang=="big5"){
						$mailsubject =  $charset->conv($mailsubject, "gb", "big5");
						$mailbody =  $charset->conv($mailbody, "gb", "big5");
					}

					if ($mail_type=="smtp"){
						$this->debug = TRUE;//是否显示发送的调试信息
						$ReturnInfo = $this->sendmail($to, $smtpusermail, $mailsubject, $mailbody, $mailtype);
					}elseif ($mail_type=="mailto"){
						$this->Mailto($to,$mailsubject,$mailbody);
					}
					break;

				case "en":
					$mailsubject = $title;
					$mailbody    = $mailtext;
					if ($mail_type=="smtp"){
						//$this->smtp($smtpserver,$smtpserverport,$auth,$smtpuser,$smtppass);
						$this->debug = TRUE;//是否显示发送的调试信息
						$ReturnInfo = $this->sendmail($to, $smtpusermail, $mailsubject, $mailbody, $mailtype);
					}elseif ($mail_type=="mailto"){
						$this->Mailto($to,$mailsubject,$mailbody);
					}
					break;

				case "big5":

					$mailsubject =  $charset->conv($title, "utf8", "big5");
					$mailbody    =  $charset->conv($mailtext, "utf8", "big5");

					if ($sel_mail_tar_lang=="zh"){
						$mailsubject =  $charset->conv($mailsubject, "big5", "gb");
						$mailbody =  $charset->conv($mailbody, "big5", "gb");
					}

					if ($mail_type=="smtp"){
						$this->debug = TRUE;//是否显示发送的调试信息
						$ReturnInfo = $this->sendmail($to, $smtpusermail,$mailsubject,$mailbody, $mailtype);
					}elseif ($mail_type=="mailto"){
						$this->Mailto($to,$mailsubject,$mailbody);
					}
					break;
			}
		}elseif ($sel_mail_enc=='utf8'){
			$mailsubject  = $title;
			$mailbody     = $mailtext;

			if ($mail_type=="smtp"){
				$this->debug = TRUE;//是否显示发送的调试信息
				$ReturnInfo = $this->sendmail($to, $smtpusermail, $mailsubject, $mailbody, $mailtype);
			}elseif ($mail_type=="mailto"){
				$this->Mailto($to,$mailsubject,$mailbody);
			}
		}
	}
}

?>